module C2

  use laplace10

  implicit none

  integer,private                           :: nz,nx
  real,private                              :: dt2,dz,dx
  real,dimension(:,:),allocatable,private   :: vel2,temp1,temp2

  contains

  subroutine C2_init(nz_in,nx_in,dt_in,vel_in,dz_in,dx_in)
    integer                :: nz_in,nx_in
    real                   :: dt_in,dz_in,dx_in
    real,dimension(:,:)    :: vel_in

    nz = nz_in
    nx = nx_in
    dt2 = dt_in
	dt2 = dt2 * dt2
    dz = dz_in
    dx = dx_in

    if (.not. allocated(vel2)) allocate(vel2(nz,nx))
    if (.not. allocated(temp1)) allocate(temp1(nz,nx))
    if (.not. allocated(temp2)) allocate(temp2(nz,nx))
        
    vel2 = vel_in
    vel2 = vel2 * vel2
    call laplace10_init(nz,nx,dz,dx)

  end subroutine

  function C2_op(adj,add,model,data) result(stat)
    logical,intent(in)       :: adj,add
    real,dimension(:)        :: model,data
    integer                  :: stat
    call C2_op2(adj,add,model,data)
    stat=0
  end function

  subroutine C2_op2(adj,add,model,data)
    logical,intent(in)              :: adj,add
    real,dimension(nz,nx)           :: model,data,temp1,temp2

    if(adj) then

        if (.not. add) model=0.
		temp1 = vel2 * dt2 * data 
        call laplace10_op2(adj,.false.,temp2,temp1)
        model = model + temp2 + 2.0 * data

    else

        if(.not. add) data = 0.
        call laplace10_op2(adj,.false.,model,temp1)
		temp1 = vel2 * dt2 * temp1 
        data = data + temp1 + 2.0 * model

    end if

  end subroutine

end module
