module D

  implicit none
  integer,private      :: nx,nz,nt
  real,private         :: dt,dt2

  contains

  subroutine D_init(nz_in,nx_in,nt_in,dt_in)
    integer            :: nx_in,nz_in,nt_in
    real               :: dt_in
    nx = nx_in
    nz = nz_in
    nt = nt_in
    dt = dt_in
    dt2 = 1.0 / (dt * dt)

  end subroutine

  function D_op(adj,add,model,data) result(stat)
    logical,intent(in)   :: adj, add
    real,dimension(:)    :: model,data
    integer              :: stat
    call D_op2(adj,add,model,data)
    stat=0
  end function

  subroutine D_op2(adj,add,model,data)
    logical                        :: adj,add
    real,dimension(nz,nx,nt)       :: model,data
    integer                        :: it,iz,ix

    if (adj) then
        if(add .eqv. .false.) model = 0.
!        model(:,:,1) = model(:,:,1) - dt2 * 2 * data(:,:,1)
!        model(:,:,2) = model(:,:,2) + dt2 *     data(:,:,1)
!        do i=2,nt-1
!            model(:,:,i-1) = model(:,:,i-1) + dt2 * data(:,:,i)
!            model(:,:,i)   = model(:,:,i)   - dt2 * data(:,:,i) * 2
!            model(:,:,i+1) = model(:,:,i+1) + dt2 * data(:,:,i)
!        end do
!        model(:,:,nt-1) = model(:,:,nt-1) + dt2 * data(:,:,nt)
!        model(:,:,nt)   = model(:,:,nt)   - dt2 * data(:,:,nt) * 2

        model(:,:,1) = model(:,:,1) + dt2 * (data(:,:,2) - 2 * data(:,:,1))
        do it=2,nt-1
           !$OMP PARALLEL DO private(iz,ix)
           do ix=1,nx
                do iz=1,nz
                    model(iz,ix,it) = model(iz,ix,it) + dt2 * (data(iz,ix,it+1) - 2 * data(iz,ix,it) + data(iz,ix,it-1))
                end do
           end do
           !$OMP END PARALLEL DO
        end do
        model(:,:,nt) = model(:,:,nt) + dt2 * (data(:,:,nt-1) - 2 * data(:,:,nt))

    else

        if(add .eqv. .false.) data = 0.
        data(:,:,1)  = data(:,:,1)  + dt2 * (model(:,:,2)    - 2 * model(:,:,1))
        do it=2,nt-1
           !$OMP PARALLEL DO private(iz,ix)
           do ix=1,nx
                do iz=1,nz
                    data(iz,ix,it) = data(iz,ix,it) + dt2 * (model(iz,ix,it+1) - 2 * model(iz,ix,it) + model(iz,ix,it-1))
                end do
           end do
           !$OMP END PARALLEL DO
        end do
        data(:,:,nt) = data(:,:,nt) + dt2 * (model(:,:,nt-1) - 2 * model(:,:,nt))

    end if

  end subroutine

end module
