module J

  implicit none

  integer,private    :: nz,nx,z_pad,x_pad
  real,private       :: dz,dx

  contains

  subroutine J_init(nz_in,nx_in,z_pad_in,x_pad_in,dz_in,dx_in)
    integer             :: nz_in,nx_in,z_pad_in,x_pad_in
    real                :: dz_in,dx_in
    nz    = nz_in
    nx    = nx_in
    z_pad = z_pad_in
    x_pad = x_pad_in
    dz    = dz_in
    dx    = dx_in

  end subroutine

  function J_op(adj,add,model,data) result(stat)
    logical,intent(in) :: adj,add
    real,dimension(:)  :: model,data
    integer            :: stat
    call J_op2(adj,add,model,data)
    stat=0
  end function

  subroutine J_op2(adj,add,model,data)
    logical,intent(in)        :: adj, add
    real,dimension(nz,nx)     :: model
    real,dimension(nz,nx)     :: data
    integer                   :: i

    if(adj) then
      if(.not. add) model = 0.

      model(1,:) = model(1,:) + data(1,:) / dz
      do i=2,z_pad
        model(i,:) = model(i,:) + (data(i,:) - data(i-1,:)) / dz
      end do
      model(z_pad+1,:) = model(z_pad+1,:) - data(z_pad,:) / dz

      model(nz-z_pad,:) = model(nz-z_pad,:) - data(nz-z_pad+1,:) / dz
      do i=nz-z_pad+1,nz-1
        model(i,:) = model(i,:) + (data(i,:) - data(i+1,:)) / dz
      end do
      model(nz,:) = model(nz,:) + data(nz,:) / dz

      model(:,1) = model(:,1) + data(:,1) / dx
      do i=2,x_pad
        model(:,i) = model(:,i) + (data(:,i) - data(:,i-1)) / dx
      end do
      model(:,x_pad+1) = model(:,x_pad+1) - data(:,x_pad) / dx

      model(:,nx-x_pad) = model(:,nx-x_pad) - data(:,nx-x_pad+1) / dx
      do i=nx-x_pad+1,nx-1
        model(:,i) = model(:,i) + (data(:,i) - data(:,i+1)) / dx
      end do
      model(:,nx) = model(:,nx) + data(:,nx) / dx

    else
      if(.not. add) data = 0.

      do i=1,z_pad
        data(i,:) = data(i,:) + (model(i,:) - model(i+1,:)) / dz
      end do

      do i=nz-z_pad+1,nz
        data(i,:) = data(i,:) + (model(i,:) - model(i-1,:)) / dz
      end do

      do i=1,x_pad
        data(:,i) = data(:,i) + (model(:,i) - model(:,i+1)) / dx
      end do

      do i=nx-x_pad+1,nx
        data(:,i) = data(:,i) + (model(:,i) - model(:,i-1)) / dx
      end do

    end if
  end subroutine

end module
