program born_adj_main

	use sep
	use pad_velocity
	use Ls_1d
	use Lr_2d
	use C5
	use weight
	use d2

  	implicit none

  	integer                                   :: nz,nx,nz2,nx2,ntw,ntw2,nts,ntr,z_pad,x_pad
  	integer									  :: i,ir,is,itw,its,it2,c_1,c_2
	integer									  :: iz,ix,it,ih,leftlag,rightlag,lag
  	integer                                   :: ns,os,ds,sz,nr,or,dr,rz,z_src,x_src
  	integer									  :: sub,shift
	real									  :: dtscat
  	real                                      :: dts,dtw,dtw2,dtr,oz,dz,ox,dx,ots,otw
  	real									  :: otr,td,fd,courant,fmax,ratio,cr
  	real									  :: oz_src,ox_src,fz_src,fx_src,ox_true,oz_true,oz_in,ox_in
	real									  :: oz_recv,ox_recv,fz_recv,fx_recv,junk,tf
  	real,dimension(:,:),allocatable           :: model,vel,small_vel,temp1,interp_filter
  	real,dimension(:),allocatable             :: sourcew,sources,sourcew_temp,sourcew_temp_dip
  	real,dimension(:,:,:),allocatable         :: data,dataw,src_wfld,recv_wfld
  	integer,dimension(:,:),allocatable        :: recv_coord,src_coord
  	logical									  :: save_src,save_recv,dip,vel_pad
  	real,dimension(:,:),allocatable,target	  :: old,cur,new,rr_left,rr_right
  	real,dimension(:,:),pointer				  :: pold,pcur,pnew,ptemp,prr_right,prr_left,prr_temp
	character(len=10)						  :: fmt1,fmt2,fmt3

  	call sep_init()
  	
  	! OUTPUT FORMAT
  	fmt1 = '(a,f5.2,a)'
	fmt2 = '(a)'
	fmt3 = '(a,f5.2)'

  	! IMPORTING PARAMETERS
  	call from_param("nz",nz)
  	call from_param("nx",nx)
  	call from_param("nts",nts)
  	call from_param("dts",dts)
  	call from_param("dz",dz)
  	call from_param("dx",dx)
  	call from_param("z_pad",z_pad)
  	call from_param("x_pad",x_pad)
  	call from_param("ns",ns)
  	call from_param("os",os)
  	call from_param("ds",ds)
  	call from_param("sz",sz)
  	call from_param("nr",nr)
  	call from_param("or",or)
  	call from_param("dr",dr)
  	call from_param("rz",rz)
  	call from_param("dip",dip)
  	call from_param("dipole_shift",shift,1)
  	call from_param("fmax",fmax)
  	call from_param("save_src",save_src,.false.)  	
  	call from_param("save_rec",save_recv,.false.)
  	call from_param("sub",sub)
  	call from_param("vel_pad",vel_pad,.false.)  	

  	call from_aux("vel","o1",oz_in)
  	call from_aux("vel","o2",ox_in)
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" !!!!!!!!!!!!!!!!!!!!
	write(0,'(a)') "!!!!!!!!!!!!! ADJOINT (NON-EXTENDED) BORN PROGRAM !!!!!!!!!!!!!"!!!!!!
	write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!" !!!!!!!!!!!!!!!!!!!!
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!		 	

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
  	if (dip .eqv. .true.) then
  		write(0,'(a)') "DIPOLE SOURCE"
  	else
  		write(0,'(a)') "MONOPOLE SOURCE"
  	end if
  	if (save_src .eqv. .true.) then
  		write(0,'(a)') "WILL WRITE SOURCE WAVEFIELD ON DISK"
  	else
  		write(0,'(a)') "WILL NOT WRITE SOURCE WAVEFIELD ON DISK"
  	end if  	
  	if (save_recv .eqv. .true.) then
  		write(0,'(a)') "WILL WRITE RECEIVER WAVEFIELD ON DISK"
  	else
  		write(0,'(a)') "WILL NOT WRITE RECEIVER WAVEFIELD ON DISK"
  	end if  		
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,fmt1) "maximum frequency fmax: ",fmax," [Hz]"
	write(0,fmt1) "dz: ",dz," [km]"
	write(0,fmt1) "dx: ",dx," [km]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
 	
  	os = os + x_pad 
  	or = or + x_pad 
  	sz = sz + z_pad 
  	rz = rz + z_pad 

  	ots = 0.
  	otw = 0.
  	otr = 0.

	dtw = dts / sub
	ntw = (nts-1) * sub + 1 
	dtr = dts
	ntr = nts

	tf = ots + (nts-1) * dts
	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,'(a,f6.3,a)') "total recording time trec: ",tf," [s]"
	write(0,'(a,i4,a)') "source number of time samples nts: ",nts," [samples]"
  	write(0,'(a,f6.3,a)') "source sampling rate dts: ",dts," [s]"
	write(0,'(a,i6,a)') "finite-difference number of time samples ntw: ",ntw," [samples]"
  	write(0,'(a,f6.3,a)') "finite-difference sampling rate dtw: ",dtw," [s]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
  	nz2 = nz + 2 * z_pad
  	nx2 = nx + 2 * x_pad	
 
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
  	write(0,'(a,i4,a)') "domain nz: ",nz," [samples]"
  	write(0,'(a,i4,a)') "domain nx: ",nx," [samples]"
  	write(0,'(a,i4,a)') "domain nz2 (after padding): ",nz2," [samples]"
  	write(0,'(a,i4,a)') "domain nx2 (after padding): ",nx2," [samples]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
 	  	
  	dtw2 = dtw * dtw
  
  	! MEMORY ALLOCATION
  	allocate(sources(nts))
  	allocate(sourcew(ntw))
  	allocate(sourcew_temp(ntw))  	
  	allocate(sourcew_temp_dip(ntw))  	  	
  	allocate(data(ntr,nr,ns))
  	allocate(dataw(ntw,nr,ns))
  	allocate(recv_coord(nr,2))
  	allocate(src_coord(ns,2))
  	allocate(vel(nz2,nx2))
  	allocate(small_vel(nz,nx))
  	allocate(old(nz2,nx2))
  	allocate(cur(nz2,nx2))
  	allocate(new(nz2,nx2))
  	allocate(rr_left(nz2,nx2))
  	allocate(rr_right(nz2,nx2))  	
  	allocate(temp1(nz2,nx2))
  	allocate(interp_filter(sub+1,2))
  	allocate(model(nz2,nx2))
	allocate(src_wfld(nz2,nx2,nts))  
  	if (save_recv .eqv. .true.) allocate(recv_wfld(nz2,nx2,nts))    	

  	pold => old
  	pcur => cur
  	pnew => new
  	
  	prr_left => rr_left
  	prr_right => rr_right

	! SOURCE WAVELET
  	call sep_read(sources,"wavelet")
  	write(0,fmt2) "read source (OK)"
  	junk = maxval(abs(sources))
  	if (junk .eq. 0) write(0,fmt2) "WARNING: source is zero"

	! VELOCITY MODEL
  	if (.not. vel_pad) then
		write(0,'(a)') "INPUT VELOCITY MODEL IS NOT PADDED"
  		call sep_read(small_vel,"vel")
  		call pad_vel(z_pad,x_pad,small_vel,vel)
  		ox = -x_pad * dx + ox_in	
 		oz = -z_pad * dz + oz_in
  		oz_true = oz_in
 		ox_true = ox_in 			
	else
		write(0,'(a)') "INPUT VELOCITY MODEL IS PADDED"
  		call sep_read(vel,"vel")
	  	ox = ox_in	
 		oz = oz_in
 		oz_true = oz + z_pad * dz
 		ox_true = ox + x_pad * dx 		
  	end if

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,fmt1) "ox: ",ox," [km]"
	write(0,fmt1) "oz: ",oz," [km]"
	write(0,fmt1) "true ox: ",ox_true," [km]"
	write(0,fmt1) "true oz: ",oz_true," [km]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
	! READ DATA
  	call sep_read(data)	
  	write(0,'(a)') "read data [Pa] (OK)"
  	if (maxval(abs(data)) .eq. 0.0) write(0,'(a)') "!!!!!! WARNING: DATA IS EMPTY !!!!!!!"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	   	

	! FINITE-DIFFERENCE STABILITY
  	courant = maxval(vel) * dtw / min(dz,dx)
  	if (courant .ge. 0.45) then
  		write(0,fmt3) "WARNING: courant number should be < 0.45, Courant: ", courant
	else 
		write(0,'(a,f4.2,a)') "Courant: ",courant, " (OK)"
	end if

	! NUMERICAL DISPERSION
  	ratio = minval(vel) / (fmax * max(dz,dx))
  	if (ratio .ge. 3) then 
  		write(0,'(a,f4.2,a)') "dispersion ratio ",ratio," (OK)"
  	else
  		write(0,fmt3) "WARNING: dispersion ratio < 3: ",ratio
  	end if
  	
	! SOURCES COORDINATES
  	src_coord(:,1) = sz
  	do is=1,ns
    	src_coord(is,2) = os + ds * (is-1)
  	end do
  	oz_src = oz + (src_coord(1,1) - 1) * dz 
  	ox_src = ox + (src_coord(1,2) - 1) * dx 
  	fz_src = oz + (src_coord(ns,1) - 1) * dz 
  	fx_src = ox + (src_coord(ns,2) - 1) * dx 
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	write(0,'(a,i4)') "number of shots: ",ns
 	write(0,'(a,f6.3,a)') "distance between two consecutive shots: ",ds*dx," [km]"
 	write(0,'(a,f6.3,a)') "depth of FIRST source: ",oz_src," [km]"
 	write(0,'(a,f6.3,a)') "offset of FIRST source: ",ox_src," [km]"	
 	write(0,'(a,f6.3,a)') "depth of LAST source: ",fz_src," [km]"
 	write(0,'(a,f6.3,a)') "offset of LAST source: ",fx_src," [km]"	  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	
	! RECEIVERS COORDINATES
  	recv_coord(:,1) = rz
  	do ir=1,nr
    	recv_coord(ir,2) = or + dr * (ir-1)
  	end do
  	oz_recv = oz + (recv_coord(1,1) - 1) * dz 
  	ox_recv = ox + (recv_coord(1,2) - 1) * dx 
  	fz_recv = oz + (recv_coord(nr,1) - 1) * dz   	
  	fx_recv = ox + (recv_coord(nr,2) - 1) * dx 
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	write(0,'(a,i4.3,a)') "number of receivers: ",nr
 	write(0,'(a,f6.3,a)') "distance between two consecutive receivers: ",dr*dx," [km]"
 	write(0,'(a,f6.3,a)') "depth of FIRST receiver: ",oz_recv," [km]"
 	write(0,'(a,f6.3,a)')"offset of FIRST receiver: ",ox_recv," [km]"	
 	write(0,'(a,f6.3,a)') "depth of LAST receiver: ",fz_recv," [km]"
 	write(0,'(a,f6.3,a)') "offset of LAST receiver: ",fx_recv," [km]"	  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	
	! PRECOMPUTE INTERPOLATION FILTER
	! WARNING: the two grids must be aligned (i.e. sub must be an integer)
	do i=1,sub+1
		interp_filter(i,1) = 1.0 - 1.0 * (i-1) / sub
		interp_filter(i,2)=1.-interp_filter(i,1)
	end do
	interp_filter = interp_filter / sqrt(real(ntw)/real(nts))  		 	
 	
	! INTERPOLATE SOURCE
  	call Ls_1d_init(nts,ntw,ots,dts,otw,dtw)
  	call Ls_1d_op2(.false.,.false.,sources,sourcew_temp) 
  	
	! TAKE THE SECOND TIME DERIVATIVE OF THE SOURCE
	call d2_init(ntw,dtw)	
	call d2_op2(.false.,.false.,sourcew_temp,sourcew)

	! INITIALIZE OPERATORS
  	call Lr_2d_init(ntr,ntw,otr,dtr,otw,dtw,nr)
  	call C5_init(nz2,nx2,dtw,vel,dz,dx,z_pad,x_pad)

  	! INITIALIZE MODEL AND SOURCE WAVEFIELD
  	model = 0.0
  	src_wfld = 0.0
  	if (save_recv .eqv. .true.) recv_wfld = 0.0
	
	! START COMPUTE TIME
  	call system_clock(count_rate=cr)
  	call system_clock(c_1)

	! LOOP OVER SHOTS 
  	do is=1,ns 
  		
  		write(0,'(a,i3,a,i3)') "computing source wavefield for shot # ",is," out of ",ns		
  	
		! initialize pointers
  		pold = 0.0
  		pcur = 0.0 
  		pnew = 0.0
  		
  		! initialize source wavefield 
  		! the source wavefield already contains the second time derivative
  		src_wfld = 0.0
  		if (save_recv .eqv. .true.) recv_wfld = 0.0  		

        ! updating source location 
        z_src = src_coord(is,1)
        x_src = src_coord(is,2)
        
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
		write(0,'(a,i4,a)') "source depth: ",z_src," [samples]"
		write(0,'(a,i4,a)') "source offset: ",x_src," [samples]"
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	         

 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!! SOURCE WAVEFIELD COMPUTATION !!!!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		! scale source  
        ! no need to apply w operator since source is inside modeling domain
        ! need to scale the negative pole of the dipole with different velocity value
		sourcew_temp = 0.0
		sourcew_temp_dip = 0.0		
  		sourcew_temp = vel(z_src,x_src) * vel(z_src,x_src) * dtw2 * sourcew
		sourcew_temp_dip = vel(z_src+shift,x_src) * vel(z_src+shift,x_src) * dtw2 * sourcew
  		
		do its=1,nts-1
		
			if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts
					
			do it2=2,sub+1

				itw = (its-1) * sub + it2

				! p(i) = C5 p(i-1) + (w-Id) p(i-2)
				call C5_op2(.false.,.false.,pcur,temp1)
				pnew = temp1
				call weight_op2(.false.,.false.,pold,temp1)
				pnew = pnew + temp1 - pold

				! inject source	
				! p(i) = p(i) + s(i-1)
				if (dip .eqv. .true.) then
					pnew(z_src,x_src) = pnew(z_src,x_src) + sourcew_temp(itw-1)
					pnew(z_src+shift,x_src) = pnew(z_src+shift,x_src) - sourcew_temp_dip(itw-1)
				else
					pnew(z_src,x_src) = pnew(z_src,x_src) + sourcew_temp(itw-1)				
				end if

				! "left" coarse index is its
				! "right" coarse index is its+1
				! spread energy for both indices
				src_wfld(:,:,its)   = src_wfld(:,:,its) + pnew * interp_filter(it2,1)
				src_wfld(:,:,its+1) = src_wfld(:,:,its+1) + pnew * interp_filter(it2,2)
			
				ptemp => pold
				pold => pcur 
				pcur => pnew
				pnew => ptemp	

			end do

		end do

  		write(0,'(a,i4,a,i4)') "finished computing source wavefield for shot # ",is," out of",ns
  		
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!! FINISHED SOURCE WAVEFIELD COMPUTATION !!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  
     	
    	! interpolate data to receiver sampling for this shot
    	call Lr_2d_op2(.false.,.false.,data(:,:,is),dataw(:,:,is))
    	
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!! RECEIVER WAVEFIELD COMPUTATION !!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

		! re-initialize pointers
  		pold = 0.0
  		pcur = 0.0 
  		pnew = 0.0
  		
  		! initialize secondary source pointers
  		prr_left = 0.0
  		prr_right = 0.0  	

  		do its=nts-1,1,-1
		
			if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts
					
			do it2=sub,1,-1

				itw = (its-1) * sub + it2

				! p(i) = C5 p(i-1) + (w-Id) p(i-2)
				call C5_op2(.true.,.false.,temp1,pcur)
				pnew = temp1
				call weight_op2(.true.,.false.,temp1,pold)
				pnew = pnew + temp1 - pold

				! inject dipole source	
				! p(i) = p(i) + s(i-1)
				if (dip .eqv. .true.) then
					do ir=1,nr
						pnew(recv_coord(ir,1),recv_coord(ir,2)) = pnew(recv_coord(ir,1),recv_coord(ir,2)) + dataw(itw+1,ir,is)
						pnew(recv_coord(ir,1)+shift,recv_coord(ir,2)) = pnew(recv_coord(ir,1)+shift,recv_coord(ir,2)) - dataw(itw+1,ir,is)
					end do
				else
					do ir=1,nr
						pnew(recv_coord(ir,1),recv_coord(ir,2)) = pnew(recv_coord(ir,1),recv_coord(ir,2)) + dataw(itw+1,ir,is)
					end do				
				end if 
				
				! interpolate to get receiver wavefield at coarse sampling
				prr_right = prr_right + pnew * interp_filter(it2,2)
				prr_left = prr_left + pnew * interp_filter(it2,1)				
				
				! save receiver wavefield at coarse sampling				
				if (save_recv .eqv. .true.) then
					recv_wfld(:,:,its+1) = recv_wfld(:,:,its+1) + pnew * interp_filter(it2,2)
					recv_wfld(:,:,its) = recv_wfld(:,:,its) + pnew * interp_filter(it2,1)
				end if
			
				ptemp => pold
				pold => pcur 
				pcur => pnew
				pnew => ptemp	

			end do

			! scale output before imaging condition 
			call weight_op2(.true.,.false.,temp1,prr_right)
			prr_right = prr_right - temp1 
			prr_right = vel * vel * dtw2 * prr_right		
			
			! apply imaging condition
			!$OMP PARALLEL DO private(ix,iz)
			do ix = 1,nx2
				do iz = 1,nz2			
					model(iz,ix) = model(iz,ix) - prr_right(iz,ix) * src_wfld(iz,ix,its+1)
				end do
			end do
			!$OMP END PARALLEL DO 			
					
			! change pointers for receiver wavefield at coarse sampling
			prr_temp => prr_right
			prr_right => prr_left
			prr_left => prr_temp
			prr_left = 0.0
			
		end do
		
 		! scale output before imaging condition for last coarse time sample 
 		call weight_op2(.true.,.false.,temp1,prr_right)
 		prr_right = prr_right - temp1 
 		prr_right = vel * vel * dtw2 * prr_right		
		
		!apply imaging condition for first time sample (its=1)
		
		!$OMP PARALLEL DO private(ix,iz)		
		do ix = 1,nx2
			do iz = 1,nz2	
				model(iz,ix) = model(iz,ix) - prr_right(iz,ix) * src_wfld(iz,ix,1)
			end do
		end do	
		!$OMP END PARALLEL DO 	

  		write(0,'(a,i4,a,i4)') "finished shot # ",is," out of",ns

  	end do	

	! SCALE MODEL 
	model = -2.0 * model / (vel * vel * vel)		
	
  	call system_clock(c_2)
  	write(0,'(a,f12.3,a)') "time spent computing: ",(c_2-c_1)/cr," [s]"  

	! WRITE MODEL ON DISK
   	write(0,fmt2) "writing model [Pa^2 s/m] on disk"
  	call sep_write(model)
   	write(0,fmt2) "writing model [Pa^2 s/m] on disk: OK"
   	
  	call to_history("n1",nz2)
  	call to_history("o1",oz)
  	call to_history("d1",dz)
  	call to_history("label1","z [km]")
  
  	call to_history("n2",nx2)
  	call to_history("o2",ox)
  	call to_history("d2",dx)
  	call to_history("label2","x [km]")
  	
  	call to_history("n3",1)
  	call to_history("o3",0.0)
  	call to_history("d3",0.0)

	! WRITE WAVEFIELDS ON DISK 	
	if (save_src .eqv. .true.) then
	
  		write(0,'(a)') "writing source wavefield on disk"

		call sep_write(src_wfld(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"src_wfld")
	
		call to_history("n1",nz,"src_wfld")	
 		call to_history("o1",oz_true,"src_wfld")
 		call to_history("d1",dz,"src_wfld")
  		call to_history("label1","z [km]","src_wfld")
 	
	 	call to_history("n2",nx,"src_wfld")
 		call to_history("o2",ox_true,"src_wfld")
 		call to_history("d2",dx,"src_wfld")
  		call to_history("label2","x [km]","src_wfld")

 		call to_history("n3",nts,"src_wfld")
 		call to_history("o3",0.0,"src_wfld")
 		call to_history("d3",dts,"src_wfld")
  		call to_history("label3","time [s]","src_wfld")
  	
	end if
  		
	if (save_recv .eqv. .true.) then
	
	  	write(0,'(a)') "writing receiver wavefield on disk"
	
 		call sep_write(recv_wfld(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"recv_wfld")
 	
 		call to_history("n1",nz,"recv_wfld")
  		call to_history("o1",oz_true,"recv_wfld")	
  		call to_history("d1",dz,"recv_wfld")
   		call to_history("label1","z [km]","recv_wfld")
  	
 	 	call to_history("n2",nx,"recv_wfld")
  		call to_history("o2",ox_true,"recv_wfld")  	
  		call to_history("d2",dx,"recv_wfld")	 	
   		call to_history("label2","x [km]","recv_wfld")
 
  		call to_history("n3",nts,"recv_wfld")
  		call to_history("o3",0.0,"recv_wfld")
  		call to_history("d3",dts,"recv_wfld")
   		call to_history("label3","time [s]","recv_wfld")

	end if

  	call sep_close()

end program


