module d2

  implicit none
  integer,private      :: nt
  real,private         :: dt,dt2

  contains

  subroutine d2_init(nt_in,dt_in)
    integer            :: nt_in
    real               :: dt_in

    nt = nt_in
    dt = dt_in
    dt2 = 1.0 / (dt * dt)

  end subroutine

  function d2_op(adj,add,model,data) result(stat)
    logical,intent(in)   :: adj, add
    real,dimension(:)    :: model,data
    integer              :: stat
    call d2_op2(adj,add,model,data)
    stat=0
  end function

  subroutine d2_op2(adj,add,model,data)
    logical                        :: adj,add
    real,dimension(nt)       	   :: model,data
    integer                        :: it

    if (adj) then
        if(add .eqv. .false.) model = 0.

        model(1) = model(1) + dt2 * (data(2) - 2 * data(1))
        do it=2,nt-1
        	model(it) = model(it) + dt2 * (data(it+1) - 2 * data(it) + data(it-1))
        end do
        model(nt) = model(nt) + dt2 * (data(nt-1) - 2 * data(nt))

    else
        if(add .eqv. .false.) data = 0.
        data(1)  = data(1)  + dt2 * (model(2) - 2 * model(1))
        do it=2,nt-1
    		data(it) = data(it) + dt2 * (model(it+1) - 2 * model(it) + model(it-1))
        end do
        data(nt) = data(nt) + dt2 * (model(nt-1) - 2 * model(nt))

    end if

  end subroutine

end module
