module dt2

	implicit none

  	integer, private				:: nt
  	real,dimension(2),private		:: coeff_o2
  	real,dimension(3),private		:: coeff_o4  	

  	contains
	
	subroutine dt2_o2_init(nt_in,dt_in)
		
		integer			:: nt_in
		real			:: dt_in
		real			:: dt

		nt = nt_in
		dt = dt_in
		coeff_o2(1) = 1.0 / (dt*dt)
		coeff_o2(2) = -2.0 / (dt*dt)

	end subroutine 

	subroutine dt2_o2_op2(model,data,it)

		real,dimension(:,:,:),allocatable 		:: model
		real,dimension(:,:),pointer 			:: data	
		integer		  	  						:: it
		
     	if(it .eq. 1) then
			data(:,:) = coeff_o2(1)*model(:,:,it+1)                   + coeff_o2(2)*model(:,:,it)
		elseif(it .eq. nt) then
			data(:,:) = coeff_o2(1)*model(:,:,it-1)                   + coeff_o2(2)*model(:,:,it)
		else
			data(:,:) = coeff_o2(1)*(model(:,:,it+1)+model(:,:,it-1)) + coeff_o2(2)*model(:,:,it)
		endif		
	
	end subroutine
	
! 	subroutine dt2_o4_init(nt_in,dt_in)
! 		
! 		integer			:: nt_in
! 		real			:: dt_in
! 		real			:: dt
! 
! 		nt = nt_in
! 		dt = dt_in
! 		coeff_o4(3) = -5.0 / 2.0 / (dt*dt)
! 		coeff_o4(2) = 4.0 / 3.0 / (dt*dt)
! 		coeff_o4(1) = -1.0 / 12.0 / (dt*dt)
! 
! 	end subroutine
! 	
! 	subroutine dt2_o4_op2(model,data,it)
! 
! 		real,dimension(:,:,:),allocatable 		:: model
! 		real,dimension(:,:),pointer 			:: data	
! 		integer		  	  						:: it
! 		
!      	if(it .eq. 1) then
! 			data(:,:) = coeff_o4(1)*model(:,:,it+2) + coeff_o4(2)*model(:,:,it+1) + coeff_o4(3)*model(:,:,it)
! 		elseif(it .eq. 2) then
! 			data(:,:) = coeff_o4(1)*model(:,:,it+2) + coeff_o4(2)*(model(:,:,it-1)+model(:,:,it+1)) + coeff_o4(3)*model(:,:,it) 
! 		else if (it .eq. nt-1) then
! 			data(:,:) = coeff_o4(1)*model(:,:,it-2) + coeff_o4(2)*(model(:,:,it-1)+model(:,:,it+1)) + coeff_o4(3)*model(:,:,it) 
! 		else if (it .eq. nt) then
! 			data(:,:) = coeff_o4(1)*model(:,:,it-2) + coeff_o4(2)*model(:,:,it-1) + coeff_o4(3)*model(:,:,it)
! 		else
! 			data(:,:) = coeff_o4(1)*(model(:,:,it+2)+model(:,:,it-2)) + coeff_o4(2)*(model(:,:,it+1)+model(:,:,it-1)) + coeff_o4(3)*model(:,:,it)
! 		endif		
! 	
! 	end subroutine 

 
	
end module 



