! this code applies a fitler to an rtm image to correct for 
! the low wavenumber artifacts
! so far I only have the Laplacian, Dzz
! 1: Dzz
! 2: Laplacian

program filter_rtm

	use sep
	use Dzz 
	use laplace10

  	implicit none

  	integer              				:: nz,nx,nh,ih,hmax,filter
  	real								:: dz,dx,dh,oz,ox,oh
  	real,dimension(:,:,:),allocatable	:: model,data

  	call sep_init()
  	
  	call from_history("n1",nz)
  	call from_history("o1",oz)
  	call from_history("d1",dz)
  	  	
  	call from_history("n2",nx)
  	call from_history("o2",ox)
  	call from_history("d2",dx)
  	  	
  	call from_history("n3",nh)
  	call from_history("o3",oh)
  	call from_history("d3",dh)
  	
  	call from_param("filter",filter,1)
  	
  	hmax = (nh - 1) / 2
  	
  	allocate(model(nz,nx,nh))
  	allocate(data(nz,nx,nh))  	
  	
  	call sep_read(model)
  	data = 0.0
  	
  	select case (filter)
  		
  		case (1) ! apply Dzz
  			
  			call Dzz_init(nz,nx,dz)
  			do ih=1,nh
  				call Dzz_op2(.false.,.false.,model(:,:,ih),data(:,:,ih))
  			end do

   		case (2) ! apply Laplacian
   			
   			call laplace10_init(nz,nx,dz,dx)
  			do ih=1,nh
  				write(0,*) "ih",ih
 				call laplace10_op2(.false.,.false.,model(:,:,ih),data(:,:,ih))
   			end do 

  	end select
  		
  	call sep_write(data)
    	
  	call to_history("n1",nz)
  	call to_history("o1",oz)
  	call to_history("d1",dz)
  	  	
  	call to_history("n2",nx)
  	call to_history("o2",ox)
  	call to_history("d2",dx)
  	  	
  	call to_history("n3",nh)
  	call to_history("o3",oh)
  	call to_history("d3",dh)	
  	
  	call sep_close()

end program