program gen_rand_mod

	use sep

  	implicit none

  	integer              				:: nz2,nx2,nz,nx,nh,hmax,nts,nr,ns
	integer								:: z_pad,x_pad
  	real								:: ots,dts,or,dr,os,ds
  	real								:: oz,dz,ox,dx,oh,dh
  	real								:: oz_true,ox_true
	real,dimension(:,:,:),allocatable   :: model,data

  	call sep_init()
  	
	call from_param("nz",nz)
	call from_param("nx",nx)	
	call from_param("z_pad",z_pad)
	call from_param("x_pad",x_pad)	
	call from_param("hmax",hmax)	
	call from_param("nts",nts)
	call from_param("nr",nr)
	call from_param("ns",ns)		
	call from_param("os",os)
	call from_param("ds",ds)
	call from_param("or",or)
	call from_param("dr",dr)		
	call from_param("dts",dts)
	call from_param("dz",dz)		
	call from_param("dx",dx)
	call from_param("oz_true",oz_true,0.0)
	call from_param("ox_true",ox_true,0.0)		
	
  	ox = -x_pad * dx + ox_true	
 	oz = -z_pad * dz + oz_true	
	
  	nz2 = nz + 2 * z_pad
  	nx2 = nx + 2 * x_pad		
	
	nh = 2 * hmax + 1 
	dh = dx
	ds = ds
	dr = dr
	oh = -hmax * dh
	
	allocate(model(nz2,nx2,-hmax:hmax))	
	allocate(data(nts,nr,ns))
	
	call random_number(model)
	call random_number(data)
	
	call sep_write(model)

	call to_history("n1",nz2)
	call to_history("o1",oz)
	call to_history("d1",dz)

	call to_history("n2",nx2)
	call to_history("o2",ox)
	call to_history("d2",dx)
	
	call to_history("n3",nh)
	call to_history("o3",oh)
	call to_history("d3",dh)	
	
	call sep_write(data,"dat")

	call to_history("n1",nts,"dat")
	call to_history("d1",dts,"dat")
	call to_history("o1",0.0,"dat")	
	
	call to_history("n2",nr,"dat")
	call to_history("d2",dr,"dat")
	call to_history("o2",or,"dat")		

	call to_history("n3",ns,"dat")
	call to_history("d3",ds,"dat")
	call to_history("o3",or,"dat")		
			
	call sep_close()					
	
end program