module pad_velocity

  implicit none

  contains

  subroutine pad_vel(z_pad,x_pad,v,padv)
    integer                             :: z_pad,x_pad,i,j,nz,nz2,nx,nx2
    real,dimension(:,:)                 :: v,padv

    nz  = size(v,1)
    nx  = size(v,2)
    nz2 = size(padv,1)
    nx2 = size(padv,2)

    padv = 0.

    do i=1,nz
        do j=1,nx
            padv(i+z_pad,j+x_pad) = v(i,j)
        end do
    end do

    do j=1,nx
        do i=1,z_pad
            padv(i,j+x_pad)           = v(1,j)
            padv(z_pad+nz+i,j+x_pad)  = v(nz,j)
        end do
    end do

    do i=1,nz2
        do j=1,x_pad
            padv(i,j)          = padv(i,x_pad+1)
            padv(i,x_pad+nx+j) = padv(i,x_pad+nx)
        end do
    end do

  end subroutine
  
end module
