program tomo_ext_fwd_dt2_main

	use sep
	use pad_velocity
	use Ls_1d
	use Lr_2d
	use C5
	use weight
	use dt2

  	implicit none

  	integer                                   :: nz,nx,nz2,nx2,ntw,ntw2,nts,ntr,z_pad,x_pad
  	integer									  :: i,ir,is,itw,its,it2,c_1,c_2
	integer									  :: iz,ix,izz1,izz2,izz,ixx1,ixx2,ixx
	integer									  :: ihz,ihx,iht,hzmax,hxmax,htmax,ihtmin,ihtmax
	integer									  :: nhz,nhx,nht
  	integer                                   :: ns,os,ds,sz,nr,or,dr,rz,z_src,x_src
  	integer									  :: sub,shift
  	real                                      :: dts,dtw,dtw2,dtr,oz,dz,ox,dx,ots,otw
  	real									  :: otr,td,fd,courant,fmax,ratio,cr,c1,c2
  	real									  :: oz_src,ox_src,fz_src,fx_src,ox_true,oz_true,oz_in,ox_in
	real									  :: oz_recv,ox_recv,fz_recv,fx_recv,junk,tf
  	real,dimension(:,:),allocatable           :: model,vel,small_vel,temp1,interp_filter,ssw,scat_wfld_dt2,src_wfld_dt2
	real,dimension(:,:,:,:,:),allocatable	  :: reflectivity
  	real,dimension(:),allocatable             :: sourcew,sources,sourcew_temp,sourcew_temp_dip
  	real,dimension(:,:,:),allocatable         :: data,dataw,src_wfld,scat_wfld1,scat_wfld2
  	integer,dimension(:,:),allocatable        :: recv_coord,src_coord
  	logical									  :: save_src,save_scat,dip,vel_pad,leg1,leg2
  	real,dimension(:,:),allocatable,target	  :: old,cur,new,ss_left,ss_right,ss_junk,ss1,ss2,ss3
  	real,dimension(:,:),pointer				  :: pold,pcur,pnew,ptemp,pss_left,pss_right,pssw,pss_temp,pss_junk,pss1,pss2,pss3
	character(len=10)						  :: fmt1,fmt2,fmt3

  	call sep_init()
  	
  	! OUTPUT FORMAT
  	fmt1 = '(a,f5.2,a)'
	fmt2 = '(a)'
	fmt3 = '(a,f5.2)'

  	! IMPORTING PARAMETERS
  	call from_param("nz",nz)
  	call from_param("nx",nx)
  	call from_param("nts",nts)
  	call from_param("dts",dts)
  	call from_param("dz",dz)
  	call from_param("dx",dx)
  	call from_param("z_pad",z_pad)
  	call from_param("x_pad",x_pad)
  	call from_param("ns",ns)
  	call from_param("os",os)
  	call from_param("ds",ds)
  	call from_param("sz",sz)
  	call from_param("nr",nr)
  	call from_param("or",or)
  	call from_param("dr",dr)
  	call from_param("rz",rz)
  	call from_param("dip",dip)
  	call from_param("dipole_shift",shift,1)
  	call from_param("fmax",fmax)
  	call from_param("save_src",save_src,.false.)
  	call from_param("save_scat",save_scat,.false.)  	
  	call from_param("sub",sub)
  	call from_param("vel_pad",vel_pad,.false.)   	
  	call from_param("leg1",leg1,.true.)
  	call from_param("leg2",leg2,.true.)
  	call from_param("hzmax",hzmax)
  	call from_param("hxmax",hxmax)
  	call from_param("htmax",htmax)  	  		

  	call from_aux("vel","o1",oz_in)
  	call from_aux("vel","o2",ox_in)
  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
	write(0,'(a)') "!!!!!!!!!!!!! FORWARD EXTENDED TOMOGRAPHIC PROGRAM !!!!!!!!!!!!!!!!!"!
	write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!		 	

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	! DISPLAY WAVEFIELD RECORDING INFORMATION
  	if (dip .eqv. .true.) then
  		write(0,'(a)') "DIPOLE SOURCE"
  	else
  		write(0,'(a)') "MONOPOLE SOURCE"
  	end if
  	if (save_src .eqv. .true.) then
  		write(0,'(a)') "WILL WRITE SOURCE WAVEFIELD ON DISK"
  	else
  		write(0,'(a)') "WILL NOT WRITE SOURCE WAVEFIELD ON DISK"
  	end if  	
  	if (save_scat .eqv. .true.) then
  		write(0,'(a)') "WILL WRITE SCATTERED WAVEFIELDS ON DISK"
  	else
  		write(0,'(a)') "WILL NOT WRITE SCATTERED WAVEFIELDS ON DISK"
  	end if  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	! DISPLAY LEGS THAT ARE BEING COMPUTED
  	if (leg1 .eqv. .false.) then
  		write(0,'(a)') "NOT COMPUTING LEG 1"
	end if
  		
  	if (leg2 .eqv. .false.) then
  		write(0,'(a)') "NOT COMPUTING LEG 2"
	end if
	
  	if ((leg1 .and. leg2) .eqv. .true.) then
  		write(0,'(a)') "COMPUTING BOTH LEGS"
	end if	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,fmt1) "maximum frequency fmax: ",fmax," [Hz]"
	write(0,fmt1) "dz: ",dz," [km]"
	write(0,fmt1) "dx: ",dx," [km]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  	os = os + x_pad 
  	or = or + x_pad 
  	sz = sz + z_pad 
  	rz = rz + z_pad 

  	ots = 0.
  	otw = 0.
  	otr = 0.

	dtw = dts / sub
	ntw = (nts-1) * sub + 1 
	dtr = dts
	ntr = nts
	
	tf = ots + (nts-1) * dts
	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,'(a,f6.3,a)') "total recording time trec: ",tf," [s]"
	write(0,'(a,i4,a)') "source number of time samples nts: ",nts," [samples]"
  	write(0,'(a,f6.3,a)') "source sampling rate dts: ",dts," [s]"
	write(0,'(a,i6,a)') "finite-difference number of time samples ntw: ",ntw," [samples]"
  	write(0,'(a,f6.3,a)') "finite-difference sampling rate dtw: ",dtw," [s]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
  	nz2 = nz + 2 * z_pad
  	nx2 = nx + 2 * x_pad	
 
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
  	write(0,'(a,i4,a)') "domain nz: ",nz," [samples]"
  	write(0,'(a,i4,a)') "domain nx: ",nx," [samples]"
  	write(0,'(a,i4,a)') "domain nz2 (after padding): ",nz2," [samples]"
  	write(0,'(a,i4,a)') "domain nx2 (after padding): ",nx2," [samples]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  	nhz = 2 * hzmax + 1
  	nhx = 2 * hxmax + 1
  	nht = 2 * htmax + 1
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
  	write(0,'(a,i4,a)') "hzmax",hzmax," [samples]"
  	write(0,'(a,f6.3,a)') "hzmax",hzmax*dz," [km]"
  	write(0,'(a,i4,a)') "hxmax",hxmax," [samples]"
  	write(0,'(a,f6.3,a)') "hxmax",hxmax*dx," [km]"
  	write(0,'(a,i4,a)') "htmax",htmax," [samples]"
  	write(0,'(a,f6.3,a)') "htmax",htmax*dts," [s]" 	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  	dtw2 = dtw * dtw
  
  	! MEMORY ALLOCATION
  	allocate(sources(nts))
  	allocate(sourcew(ntw))
  	allocate(sourcew_temp(ntw))  	
  	allocate(sourcew_temp_dip(ntw))  	  	
  	allocate(data(ntr,nr,ns))
  	allocate(dataw(ntw,nr,ns))
  	allocate(recv_coord(nr,2))
  	allocate(src_coord(ns,2))
  	allocate(vel(nz2,nx2))
  	allocate(small_vel(nz,nx))
  	allocate(old(nz2,nx2))
  	allocate(cur(nz2,nx2))
  	allocate(new(nz2,nx2))
  	allocate(ss_left(nz2,nx2))
  	allocate(ss_right(nz2,nx2))  	
  	allocate(ss_junk(nz2,nx2))  	
  	allocate(ss1(nz2,nx2))  	
  	allocate(ss2(nz2,nx2))
  	allocate(ss3(nz2,nx2))
  	allocate(scat_wfld_dt2(nz2,nx2))  	  	
  	allocate(src_wfld_dt2(nz2,nx2))  	  	  	
  	allocate(temp1(nz2,nx2))
  	allocate(interp_filter(sub+1,2))
  	allocate(model(nz2,nx2))
  	allocate(reflectivity(nz2,nx2,-hzmax:hzmax,-hxmax:hxmax,-htmax:htmax))
  	allocate(ssw(nz2,nx2))	
	allocate(src_wfld(nz2,nx2,nts))  
	allocate(scat_wfld1(nz2,nx2,nts))  	
  	if (save_scat) allocate(scat_wfld2(nz2,nx2,nts)) 

  	pold => old
  	pcur => cur
  	pnew => new
  	
  	pss_left => ss_left
  	pss_right => ss_right
  	
  	pss_junk => ss_junk
  	pss1 => ss1
  	pss2 => ss2
  	pss3 => ss3  	

	! SOURCE WAVELET
  	call sep_read(sources,"wavelet")
  	write(0,fmt2) "read source [OK]"
  	junk = maxval(abs(sources))	
  	if (junk .eq. 0) write(0,fmt2) "WARNING: source is zero"	

	! VELOCITY MODEL
  	if (.not. vel_pad) then
		write(0,'(a)') "INPUT VELOCITY MODEL IS NOT PADDED"
  		call sep_read(small_vel,"vel")
  		call pad_vel(z_pad,x_pad,small_vel,vel)
  		ox = -x_pad * dx + ox_in	
 		oz = -z_pad * dz + oz_in
 		oz_true = oz_in
 		ox_true = ox_in 		
	else
		write(0,'(a)') "INPUT VELOCITY MODEL IS PADDED"
  		call sep_read(vel,"vel")
	  	ox = ox_in	
 		oz = oz_in
 		oz_true = oz + z_pad * dz
 		ox_true = ox + x_pad * dx
  	end if

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	write(0,fmt1) "ox: ",ox," [km]"
	write(0,fmt1) "oz: ",oz," [km]"
	write(0,fmt1) "true ox: ",ox_true," [km]"
	write(0,fmt1) "true oz: ",oz_true," [km]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
  	if (.not. vel_pad) write(0,'(a,f5.3,a)') "max value of vel model before padding: ",maxval(small_vel)," [km/s]"
  	if (.not. vel_pad) write(0,'(a,f5.3,a)') "min value of vel model before padding: ",minval(small_vel)," [km/s]"
  	write(0,'(a,f5.3,a)') "max value of vel model after padding: ",maxval(vel)," [km/s]"
  	write(0,'(a,f5.3,a)') "min value of vel model after padding: ",minval(vel)," [km/s]"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
	! REFLECTIVITY PERTURBATION [km/s]
  	call sep_read(reflectivity,"reflectivity")
  	write(0,'(a)') "read reflectivity model [OK]"
  	if (maxval(abs(reflectivity)) .eq. 0) write(0,fmt2) "WARNING: REFLECTIVITY IS NULL"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 

 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
	! BACKGROUND VELOCITY PERTURBATION [km/s]
  	call sep_read(model)
  	write(0,'(a)') "read model [OK]"
  	if (maxval(abs(model)) .eq. 0) write(0,fmt2) "WARNING: MODEL IS NULL"
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 

	! FINITE-DIFFERENCE STABILITY
  	courant = maxval(vel) * dtw / min(dz,dx)
  	if (courant .ge. 0.45) then
  		write(0,fmt3) "WARNING: courant number should be < 0.45, Courant: ", courant
	else 
		write(0,'(a,f4.2,a)') "Courant: ",courant, " [OK]"
	end if

	! NUMERICAL DISPERSION
  	ratio = minval(vel) / (fmax * max(dz,dx))
  	if (ratio .ge. 3) then 
  		write(0,'(a,f4.2,a)') "dispersion ratio ",ratio," [OK]"
  	else
  		write(0,fmt3) "WARNING: dispersion ratio < 3: ",ratio
  	end if
  	
	! SOURCES COORDINATES
  	src_coord(:,1) = sz
  	do is=1,ns
    	src_coord(is,2) = os + ds * (is-1)
  	end do
  	oz_src = oz + (src_coord(1,1) - 1) * dz 
  	ox_src = ox + (src_coord(1,2) - 1) * dx 
  	fz_src = oz + (src_coord(ns,1) - 1) * dz 
  	fx_src = ox + (src_coord(ns,2) - 1) * dx 
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	write(0,'(a,i4)') "number of shots: ",ns
 	write(0,'(a,f6.3,a)') "distance between two consecutive shots: ",ds*dx," [km]"
 	write(0,'(a,f6.3,a)') "depth of FIRST source: ",oz_src," [km]"
 	write(0,'(a,f6.3,a)') "offset of FIRST source: ",ox_src," [km]"	
 	write(0,'(a,f6.3,a)') "depth of LAST source: ",fz_src," [km]"
 	write(0,'(a,f6.3,a)') "offset of LAST source: ",fx_src," [km]"	  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	
	! RECEIVERS COORDINATES
  	recv_coord(:,1) = rz
  	do ir=1,nr
    	recv_coord(ir,2) = or + dr * (ir-1)
  	end do
  	oz_recv = oz + (recv_coord(1,1) - 1) * dz 
  	ox_recv = ox + (recv_coord(1,2) - 1) * dx 
  	fz_recv = oz + (recv_coord(nr,1) - 1) * dz   	
  	fx_recv = ox + (recv_coord(nr,2) - 1) * dx 
  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	write(0,'(a,i4.3,a)') "number of receivers: ",nr
 	write(0,'(a,f6.3,a)') "distance between two consecutive receivers: ",dr*dx," [km]"
 	write(0,'(a,f6.3,a)') "depth of FIRST receiver: ",oz_recv," [km]"
 	write(0,'(a,f6.3,a)')"offset of FIRST receiver: ",ox_recv," [km]"	
 	write(0,'(a,f6.3,a)') "depth of LAST receiver: ",fz_recv," [km]"
 	write(0,'(a,f6.3,a)') "offset of LAST receiver: ",fx_recv," [km]"	  	  	
 	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
 	
	! PRECOMPUTE INTERPOLATION FILTER
	! WARNING: the two time grids must be aligned (i.e. sub must be an integer)
	do i=1,sub+1
		interp_filter(i,1) = 1.0 - 1.0 * (i-1) / sub
		interp_filter(i,2)=1.-interp_filter(i,1)
	end do
	interp_filter = interp_filter / sqrt(real(ntw)/real(nts))  		 	
 	
	! INTERPOLATE SOURCE
  	call Ls_1d_init(nts,ntw,ots,dts,otw,dtw)
  	call Ls_1d_op2(.false.,.false.,sources,sourcew_temp) 
  	
	sourcew = sourcew_temp

	! INITIALIZE OPERATORS
  	call Lr_2d_init(ntr,ntw,otr,dtr,otw,dtw,nr)
  	call C5_init(nz2,nx2,dtw,vel,dz,dx,z_pad,x_pad)
  	
 	! INITIALIZE DERIVATIVE FD COEFFICIENTS
	c1 = -2.0 / (dts*dts)
	c2 = 1.0 / (dts*dts) 	
  	
  	! SCALE VELOCITY PERTURBATIONS 
	do iht=-htmax,htmax
		do ihx=-hxmax,hxmax
			do ihz=-hzmax,hzmax
				reflectivity(:,:,ihz,ihx,iht) = -2.0 * reflectivity(:,:,ihz,ihx,iht) / (vel * vel * vel)		
			end do
		end do
	end do

	model = -2.0 * model / (vel * vel * vel)		

  	! INITIALIZE DATA
  	dataw = 0.0
  	data  = 0.0
  	src_wfld = 0.0
  	scat_wfld1 = 0.0
  	if (save_scat) scat_wfld2 = 0.0
	
	! START COMPUTE TIME
  	call system_clock(count_rate=cr)
  	call system_clock(c_1)

	! LOOP OVER SHOTS
  	do is=1,ns 
  		
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
		write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
		write(0,'(a)') "!!!!!!!!!!!!!!!!!!! SOURCE WAVEFIELD COMPUTATION !!!!!!!!!!!!!!!!!!!"!
		write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  		write(0,'(a,i4,a,i4)') "SHOT ",is," OUT OF",ns  	
  	
		! initialize pointers
  		pold = 0.0
  		pcur = 0.0 
  		pnew = 0.0
  		
  		! initialize source wavefield 
  		src_wfld = 0.0

        ! updating source location 
        z_src = src_coord(is,1)
        x_src = src_coord(is,2)
        
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	 
		write(0,'(a,i4,a)') "source depth: ",z_src," [samples]"
		write(0,'(a,i4,a)') "source offset: ",x_src," [samples]"
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	         

		!!!!!!!!!! THE SOURCE WAVEFIELD IS COMPUTED AND USED BY BOTH LEGS !!!!!!!!!!!!!!!!

		! scale source  
        ! no need to apply w operator since source is inside modeling domain
        ! when using a dipole source, 
        ! we need to scale the negative pole of the dipole with different velocity value

		sourcew_temp = 0.0
		sourcew_temp_dip = 0.0		
  		sourcew_temp = vel(z_src,x_src) * vel(z_src,x_src) * dtw2 * sourcew
		sourcew_temp_dip = vel(z_src+shift,x_src) * vel(z_src+shift,x_src) * dtw2 * sourcew
  		
		do its=1,nts-1
		
			if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts
					
			do it2=2,sub+1

				itw = (its-1) * sub + it2

				! p(i) = C5 p(i-1) + (w-Id) p(i-2)
				call C5_op2(.false.,.false.,pcur,temp1)
				pnew = temp1
				call weight_op2(.false.,.false.,pold,temp1)
				pnew = pnew + temp1 - pold

				! inject source	
				! p(i) = p(i) + s(i-1)
				if (dip .eqv. .true.) then
					pnew(z_src,x_src) = pnew(z_src,x_src) + sourcew_temp(itw-1)
					pnew(z_src+shift,x_src) = pnew(z_src+shift,x_src) - sourcew_temp_dip(itw-1)
				else
					pnew(z_src,x_src) = pnew(z_src,x_src) + sourcew_temp(itw-1)				
				end if

				! "left" coarse index is its
				! "right" coarse index is its+1
				! spread energy for both indices
				src_wfld(:,:,its)   = src_wfld(:,:,its) + pnew * interp_filter(it2,1)
				src_wfld(:,:,its+1) = src_wfld(:,:,its+1) + pnew * interp_filter(it2,2)
			
				ptemp => pold
				pold => pcur 
				pcur => pnew
				pnew => ptemp	

			end do

		end do

		if (save_src) then 
			call sep_write(src_wfld(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"src_wfld")  		
		end if
		
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!! FINISHED SOURCE WAVEFIELD COMPUTATION !!!!!!!!!!!!!!!!!!!!!!!!
 		!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!  		

		if (leg1) then

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!! STARTING COMPUTATION OF LEG 1: !!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!! SOURCE -> REFLECTIVITY -> BACKGROUND -> RECEIVER !!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  			write(0,'(a,i4,a,i4)') "SHOT ",is," OUT OF",ns  	

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! INITIALIZATION OF FIRST SECONDARY SOURCE FOR LEG 1 !!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

  			! initialize first scattered wavefield 
			scat_wfld1 = 0.0

  			! initialize second scattered wavefield 
  			if (save_scat .eqv. .true.) scat_wfld2 = 0.0

			! initialize pointers for secondary source
			pss1 = 0.0
			pss2 = 0.0
			pss3 = 0.0

			! re-initialize pointers
			pold = 0.0
			pcur = 0.0 
			pnew = 0.0
		
			! initialize secondary source pointers
			pss_left = 0.0
			pss_right = 0.0  		

			! compute secondary source without time derivative for its = 1 and its = 2 		
			do its = 1,2

				ihtmax = (its-1) / 2
				ihtmax = min(ihtmax,htmax)
				ihtmin = (its-nts) / 2
				ihtmin = max(-htmax,ihtmin)		

				do iht = ihtmin,ihtmax	
					!$OMP PARALLEL DO private(ix,ixx1,ixx2,ixx,ihx,iz,izz1,izz2,izz,ihz)
					do ix = 1,nx2					
						ixx1 = ceiling((1.0+ix) / 2.0)
						ixx1 = max(ix-hxmax,ixx1)
						ixx2 = (nx2+ix) / 2
						ixx2 = min((hxmax+ix),ixx2)				
						do ixx = ixx1,ixx2					
							ihx = ix - ixx			
							do iz = 1,nz2
								izz1 = ceiling((1.0+iz) / 2.0)
								izz1 = max(iz-hzmax,izz1)
								izz2 = (nz2+iz) / 2
								izz2 = min((hzmax+iz),izz2)												
								do izz = izz1,izz2									
									ihz = iz - izz							
									if (its .eq. 1) then
										pss1(iz,ix) = pss1(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * src_wfld(iz-2*ihz,ix-2*ihx,its-2*iht)									
									else
										pss2(iz,ix) = pss2(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * src_wfld(iz-2*ihz,ix-2*ihx,its-2*iht)			
									end if
								end do
							end do		
						end do
					end do		
   					!$OMP END PARALLEL DO	
				end do
			end do
					
			! compute the second time derivative of the secondary source (coarse grid) for its = 1
			pss_left = c1 * pss1 + c2 * pss2	
		
			! scale first time sample of secondary source (coarse grid)		 
			! apply [v2 * dtw2] to pss_left
			pss_left = vel * vel * dtw2	* pss_left
		
			! apply (I-w) to pss_left
	    	call weight_op2(.false.,.false.,pss_left,temp1)
			pss_left = pss_left - temp1

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! FINISHED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! INITIALIZATION OF FIRST SECONDARY SOURCE FOR LEG 1 !!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!! LEG 1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!! COMPUTATION OF FIRST SCATTERED WAVEFIELD !!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
			! main loop for scattered wavefield propagation
			do its=1,nts-1
		
				! display time sample
				if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts				

				! check if its = nts-1
				if (its .lt. nts-1) then
			
					! compute convolution of the source wavefield and the reflectivity 
					! for coarse sampling at time slice its + 2
					ihtmax = (its+1) / 2
					ihtmax = min(ihtmax,htmax)
					ihtmin = (its+2-nts) / 2
					ihtmin = max(-htmax,ihtmin)			
			
					do iht = ihtmin,ihtmax	
						!$OMP PARALLEL DO private(ix,ixx1,ixx2,ixx,ihx,iz,izz1,izz2,izz,ihz)					
						do ix = 1,nx2
							ixx1 = ceiling((1.0+ix) / 2.0)
							ixx1 = max(ix-hxmax,ixx1)
							ixx2 = (nx2+ix) / 2
							ixx2 = min((hxmax+ix),ixx2)				
							do ixx = ixx1,ixx2					
								ihx = ix - ixx			
								do iz = 1,nz2
									izz1 = ceiling((1.0+iz) / 2.0)
									izz1 = max(iz-hzmax,izz1)
									izz2 = (nz2+iz) / 2
									izz2 = min((hzmax+iz),izz2)					
									do izz = izz1,izz2									
										ihz = iz - izz							
										pss3(iz,ix) = pss3(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * src_wfld(iz-2*ihz,ix-2*ihx,its+2-2*iht)
									end do
								end do
							end do		
						end do
       					!$OMP END PARALLEL DO						
					end do							

				end if						
							
				! compute the second time derivative of the secondary source for its + 1
				pss_right =  c1 * pss2 + c2 * (pss1 + pss3)

				! scale the "right" time sample of secondary source (coarse grid)		 
				! apply [v2 * dtw2] to pss_right
				pss_right = vel * vel * dtw2 * pss_right			

				! apply (I-w) to pss_right
				call weight_op2(.false.,.false.,pss_right,temp1)
				pss_right = pss_right - temp1

				! now both samples of the secondary source are scaled and  
				! the scaled secondary source at the fine sampling can be computed 
				! between these points

				! loop over the sub-block
				do it2=2,sub+1

					! compute fine time sample index
					itw = (its-1) * sub + it2	

					! update the scattered wavefield without the secondary source
					! p(i) = C5 p(i-1) + (w-Id) p(i-2)
					call C5_op2(.false.,.false.,pcur,temp1)
					pnew = temp1
					call weight_op2(.false.,.false.,pold,temp1)
					pnew = pnew + temp1 - pold
				
					! interpolate secondary source to fine grid between its and its+1
					! compute scaled secondary source at itw-1
					ssw = pss_left * interp_filter(it2-1,1) + pss_right * interp_filter(it2-1,2)

					! inject secondary source
					pnew = pnew + ssw

					! save scattered wavefield at coarse sampling 
					scat_wfld1(:,:,its) = scat_wfld1(:,:,its) + pnew * interp_filter(it2,1)
					scat_wfld1(:,:,its+1) = scat_wfld1(:,:,its+1) + pnew * interp_filter(it2,2)

					! switch pointers within the same sub-block
					ptemp => pold
					pold => pcur 
					pcur => pnew
					pnew => ptemp	

				end do
	
				! finished scattering and recording for the sub-block
				! switching pointers for the secondary sources
				pss_temp => pss_left
				pss_left => pss_right
				pss_right => pss_temp
				pss_right = 0.0

				! switch pointers for the secondary source before time derivatives
				pss_junk => pss1
				pss1 => pss2
				pss2 => pss3 
				pss3 => pss_junk
				pss3 = 0.0

			end do

			! save the first scattered wavefield of leg 1 on disk 
			if (save_scat .eqv. .true.) then
				call sep_write(scat_wfld1(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"scat_wfld1_leg1")
			end if

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! FINISHED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!			
			!!!!!!!!!!!!!!! LEG 1: COMPUTATION OF FIRST SCATTERED WAVEFIELD !!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! INITIALIZATION OF SECOND SECONDARY SOURCE FOR LEG 1 !!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

			! re-initialize pointers
			pold = 0.0
			pcur = 0.0 
			pnew = 0.0
		
			! initialize secondary source pointers
			pss_left = 0.0
			pss_right = 0.0  		
		
			! apply second time derivative to scattered wavefield
			scat_wfld_dt2 = c1 * scat_wfld1(:,:,1) + c2 * scat_wfld1(:,:,2)
			
			! compute secondary source (coarse grid) at its = 1

			!$OMP PARALLEL DO private(ix,iz)
			do ix = 1,nx2
				do iz = 1,nz2
					pss_left(iz,ix) = pss_left(iz,ix) - scat_wfld_dt2(iz,ix) * model(iz,ix)
				end do
			end do
			!$OMP END PARALLEL DO				
		
			! scale first time sample of secondary source (coarse grid)		 
			! apply [v2 * dtw2] to pss_left
			pss_left = vel * vel * dtw2	* pss_left
		
			! apply (I-w) to pss_left
			call weight_op2(.false.,.false.,pss_left,temp1)
			pss_left = pss_left - temp1

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! FINISHED INITIALIZATION OF SECONDARY SOURCE FOR LEG 1 !!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!! LEG 1 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!! COMPUTATION OF SECOND SCATTERED WAVEFIELD !!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	
			! main loop for scattered wavefield propagation
			do its=1,nts-1
		
				! display time sample
				if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts				

				if (its .lt. nts-1) then
					! apply second time derivative to scattered wavefield at its + 1
					scat_wfld_dt2 = c1 * scat_wfld1(:,:,its+1) + c2 * (scat_wfld1(:,:,its+2)+scat_wfld1(:,:,its))				
				else 
					scat_wfld_dt2 = c1 * scat_wfld1(:,:,its+1) + c2 * scat_wfld1(:,:,its)
				end if

				! compute convolution of the source wavefield and the background perturbation 
				! for coarse time slice its + 1

				!$OMP PARALLEL DO private(ix,iz)
				do ix = 1,nx2
					do iz = 1,nz2
						pss_right(iz,ix) = pss_right(iz,ix) - scat_wfld_dt2(iz,ix) * model(iz,ix)
					end do
				end do	
				!$OMP END PARALLEL DO										
								
				! scale the "right" time sample of secondary source (coarse grid)		 
				! apply [v2 * dtw2] to pss_right
				pss_right = vel * vel * dtw2 * pss_right			

				! apply (I-w) to pss_right
				call weight_op2(.false.,.false.,pss_right,temp1)
				pss_right = pss_right - temp1

				! now both samples of the secondary source are scaled and  
				! the scaled secondary source at the fine sampling can be computed 
				! between these points

				! loop over the sub-block
				do it2=2,sub+1

					! compute fine time sample index
					itw = (its-1) * sub + it2	

					! update the scattered wavefield without the secondary source
					! p(i) = C5 p(i-1) + (w-Id) p(i-2)
					call C5_op2(.false.,.false.,pcur,temp1)
					pnew = temp1
					call weight_op2(.false.,.false.,pold,temp1)
					pnew = pnew + temp1 - pold
				
					! interpolate secondary source to fine grid between its and its+1
					! compute scaled secondary source at itw-1
					ssw = pss_left * interp_filter(it2-1,1) + pss_right * interp_filter(it2-1,2)

					! inject secondary source
					pnew = pnew + ssw

					! save scattered wavefield at coarse sampling 
					if (save_scat .eqv. .true.) then
						scat_wfld2(:,:,its) = scat_wfld2(:,:,its) + pnew * interp_filter(it2,1)
						scat_wfld2(:,:,its+1) = scat_wfld2(:,:,its+1) + pnew * interp_filter(it2,2)
					end if
				
					! record data at fine sampling
					if (dip .eqv. .true.) then
						do ir=1,nr
							dataw(itw,ir,is) = dataw(itw,ir,is) + pnew(recv_coord(ir,1),recv_coord(ir,2)) 
							dataw(itw,ir,is) = dataw(itw,ir,is) - pnew(recv_coord(ir,1)+shift,recv_coord(ir,2)) 
						end	do
					else
						do ir=1,nr
							dataw(itw,ir,is) = dataw(itw,ir,is) + pnew(recv_coord(ir,1),recv_coord(ir,2)) 
						end	do
					end if
								
					! switch pointers within the same sub-block
					ptemp => pold
					pold => pcur 
					pcur => pnew
					pnew => ptemp	

				end do
			
				! finished scattering and recording for the sub-block
				! switching pointers for the secondary sources
				pss_temp => pss_left
				pss_left => pss_right
				pss_right => pss_temp
				pss_right = 0.0

			end do

			! save the second scattered wavefield of leg 1 on disk 
			if (save_scat .eqv. .true.) then
				call sep_write(scat_wfld2(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"scat_wfld2_leg1")
			end if

 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!! FINISHED COMPUTATION OF LEG 1 !!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

		end if
			
		if (leg2) then

 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! LEG 2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!! SOURCE -> BACKGROUND -> REFLECTIVITY -> RECEIVER !!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!! STARTING COMPUTATION OF LEG 2: !!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!! SOURCE -> BACKGROUND -> REFLECTIVITY -> RECEIVER !!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

  			write(0,'(a,i4,a,i4)') "SHOT ",is," OUT OF",ns  	

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! INITIALIZATION OF FIRST SECONDARY SOURCE FOR LEG 2 !!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  			! initialize first scattered wavefield 
			scat_wfld1 = 0.0

  			! initialize second scattered wavefield 
  			if (save_scat) scat_wfld2 = 0.0

			! re-initialize pointers
			pold = 0.0
			pcur = 0.0 
			pnew = 0.0
		
			! initialize secondary source pointers
			pss_left = 0.0
			pss_right = 0.0  		
		
			! compute the second time derivative of the source wavefield at its = 1
			scat_wfld_dt2 = c1 * src_wfld(:,:,1) + c2 * src_wfld(:,:,2)

			! compute first time sample of secondary source (coarse grid)

			!$OMP PARALLEL DO private(ix,iz)
			do ix = 1,nx2
				do iz = 1,nz2
					pss_left(iz,ix) = pss_left(iz,ix) - src_wfld_dt2(iz,ix) * model(iz,ix)
				end do
			end do
			!$OMP END PARALLEL DO			
		
			! scale first time sample of secondary source (coarse grid)		 
			! apply [v2 * dtw2] to pss_left
			pss_left = vel * vel * dtw2	* pss_left
		
			! apply (I-w) to pss_left
			call weight_op2(.false.,.false.,pss_left,temp1)
			pss_left = pss_left - temp1
		
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!! FINISHED INITIALIZATION OF FIRST SECONDARY SOURCE FOR LEG 2 !!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!! LEG 2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!! COMPUTATION OF FIRST SCATTERED WAVEFIELD !!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		
			! main loop for scattered wavefield propagation
			do its=1,nts-1
		
				! display time sample
				if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts				

				! we want to compute the secondary source at its + 1
				
				! apply second time derivative of source wavefield at its + 1
				if (its .lt. nts-1) then
					src_wfld_dt2 = c1 *src_wfld(:,:,its+1) + c2 * (src_wfld(:,:,its+2)+src_wfld(:,:,its))
				else 
					src_wfld_dt2 = c1 *src_wfld(:,:,its+1) + c2 * src_wfld(:,:,its)
				end if

				! compute convolution of the source wavefield and the reflectivity 
				! for coarse time slice its + 1

				!$OMP PARALLEL DO private(ix,iz)
				do ix = 1,nx2
					do iz = 1,nz2
						pss_right(iz,ix) = pss_right(iz,ix) - src_wfld_dt2(iz,ix) * model(iz,ix)
					end do
				end do
				!$OMP END PARALLEL DO
								
				! scale the "right" time sample of secondary source (coarse grid)		 
				! apply [v2 * dtw2] to pss_right
				pss_right = vel * vel * dtw2 * pss_right			

				! apply (I-w) to pss_right
				call weight_op2(.false.,.false.,pss_right,temp1)
				pss_right = pss_right - temp1

				! now both samples of the secondary source are scaled and  
				! the scaled secondary source at the fine sampling can be computed 
				! between these points

				! loop over the sub-block
				do it2=2,sub+1

					! compute fine time sample index
					itw = (its-1) * sub + it2	

					! update the scattered wavefield without the secondary source
					! p(i) = C5 p(i-1) + (w-Id) p(i-2)
					call C5_op2(.false.,.false.,pcur,temp1)
					pnew = temp1
					call weight_op2(.false.,.false.,pold,temp1)
					pnew = pnew + temp1 - pold
				
					! interpolate secondary source to fine grid between its and its+1
					! compute scaled secondary source at itw-1
					ssw = pss_left * interp_filter(it2-1,1) + pss_right * interp_filter(it2-1,2)

					! inject secondary source
					pnew = pnew + ssw

					! save scattered wavefield at coarse sampling 
					scat_wfld1(:,:,its) = scat_wfld1(:,:,its) + pnew * interp_filter(it2,1)
					scat_wfld1(:,:,its+1) = scat_wfld1(:,:,its+1) + pnew * interp_filter(it2,2)

					! switch pointers within the same sub-block
					ptemp => pold
					pold => pcur 
					pcur => pnew
					pnew => ptemp	

				end do
			
				! finished scattering and recording for the sub-block
				! switching pointers for the secondary sources
				pss_temp => pss_left
				pss_left => pss_right
				pss_right => pss_temp
				pss_right = 0.0

			end do

			! save the first scattered wavefield of leg 2 on disk 
			if (save_scat) then
				call sep_write(scat_wfld1(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"scat_wfld1_leg2")
			end if

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! FINISHED !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			!!!!!!!!!!!!!!! LEG 2: COMPUTATION OF FIRST SCATTERED WAVEFIELD !!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! INITIALIZATION OF SECOND SECONDARY SOURCE FOR LEG 2 !!!!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 

  			! initialize second scattered wavefield 
  			if (save_scat .eqv. .true.) scat_wfld2 = 0.0

			! initialize pointers for secondary source
			pss1 = 0.0
			pss2 = 0.0
			pss3 = 0.0

			! re-initialize pointers
			pold = 0.0
			pcur = 0.0 
			pnew = 0.0
		
			! initialize secondary source pointers
			pss_left = 0.0
			pss_right = 0.0  		

			! compute secondary source without time derivative for its=1 and its=2
			do its = 1,2

				ihtmax = (its-1) / 2
				ihtmax = min(ihtmax,htmax)
				ihtmin = (its-nts) / 2
				ihtmin = max(-htmax,ihtmin)		

				do iht = ihtmin,ihtmax	
					!$OMP PARALLEL DO private(ix,ixx1,ixx2,ixx,ihx,iz,izz1,izz2,izz,ihz)
					do ix = 1,nx2					
						ixx1 = ceiling((1.0+ix) / 2.0)
						ixx1 = max(ix-hxmax,ixx1)
						ixx2 = (nx2+ix) / 2
						ixx2 = min((hxmax+ix),ixx2)
						do ixx = ixx1,ixx2					
							ihx = ix - ixx			
							do iz = 1,nz2
								izz1 = ceiling((1.0+iz) / 2.0)
								izz1 = max(iz-hzmax,izz1)
								izz2 = (nz2+iz) / 2
								izz2 = min((hzmax+iz),izz2)												
								do izz = izz1,izz2									
									ihz = iz - izz							
									if (its .eq. 1) then
										! compute secondary source before time derivative at its = 1
										pss1(iz,ix) = pss1(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * scat_wfld1(iz-2*ihz,ix-2*ihx,its-2*iht)
									else
										! compute secondary source before time derivative at its = 2
										pss2(iz,ix) = pss2(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * scat_wfld1(iz-2*ihz,ix-2*ihx,its-2*iht)
									end if
								end do
							end do		
						end do
					end do		
					!$OMP END PARALLEL DO
				end do
			end do

			! compute the second time derivative of the secondary source at its = 1
			pss_left = c1 * pss1 + c2 * pss2	
		
			! scale first time sample of secondary source (coarse grid)		 
			! apply [v2 * dtw2] to pss_left
			pss_left = vel * vel * dtw2	* pss_left
		
			! apply (I-w) to pss_left
	    	call weight_op2(.false.,.false.,pss_left,temp1)
			pss_left = pss_left - temp1

			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			!!!!!!!!!!!!!!!!!!! FINISHED INITIALIZATION OF SECONDARY SOURCE FOR LEG 2 !!!!!!!!
			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
 
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!! LEG 2 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!! COMPUTATION OF SECOND SCATTERED WAVEFIELD !!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
	
			! main loop for scattered wavefield propagation
			do its=1,nts-1
		
				! display time sample
				if (modulo(its,nts/5) .eq. 0) write(0,'(a,i4,a,i4)') "its= ",its," out of ",nts				

				! check if its = nts-1
				if (its .lt. nts-1) then
			
					! compute convolution of the source wavefield and the reflectivity at its + 2
					ihtmax = (its+1) / 2
					ihtmax = min(ihtmax,htmax)
					ihtmin = (its+2-nts) / 2
					ihtmin = max(-htmax,ihtmin)			
			
					do iht = ihtmin,ihtmax	
						!$OMP PARALLEL DO private(ix,ixx1,ixx2,ixx,ihx,iz,izz1,izz2,izz,ihz)
						do ix = 1,nx2
							ixx1 = ceiling((1.0+ix) / 2.0)
							ixx1 = max(ix-hxmax,ixx1)
							ixx2 = (nx2+ix) / 2
							ixx2 = min((hxmax+ix),ixx2)			
							do ixx = ixx1,ixx2		
								ihx = ix - ixx			
								do iz = 1,nz2
									izz1 = ceiling((1.0+iz) / 2.0)
									izz1 = max(iz-hzmax,izz1)
									izz2 = (nz2+iz) / 2
									izz2 = min((hzmax+iz),izz2)					
									do izz = izz1,izz2									
										ihz = iz - izz							
										pss3(iz,ix) = pss3(iz,ix) - reflectivity(izz,ixx,ihz,ihx,iht) * scat_wfld1(iz-2*ihz,ix-2*ihx,its+2-2*iht)
									end do
								end do
							end do		
						end do
						!$OMP END PARALLEL DO
					end do							

				end if						
							
				! compute the second time derivative of the secondary source for its + 1
				pss_right =  c1 * pss2 + c2 * (pss1 + pss3)

				! scale the "right" time sample of secondary source (coarse grid)	 
				! apply [v2 * dtw2] to pss_right
				pss_right = vel * vel * dtw2 * pss_right			

				! apply (I-w) to pss_right
				call weight_op2(.false.,.false.,pss_right,temp1)
				pss_right = pss_right - temp1

				! now both samples of the secondary source are scaled and  
				! the scaled secondary source at the fine sampling can be computed 
				! between these points

				! loop over the sub-block
				do it2=2,sub+1

					! compute fine time sample index
					itw = (its-1) * sub + it2	

					! update the scattered wavefield without the secondary source
					! p(i) = C5 p(i-1) + (w-Id) p(i-2)
					call C5_op2(.false.,.false.,pcur,temp1)
					pnew = temp1
					call weight_op2(.false.,.false.,pold,temp1)
					pnew = pnew + temp1 - pold
				
					! interpolate secondary source to fine grid between its and its+1
					! compute scaled secondary source at itw-1
					ssw = pss_left * interp_filter(it2-1,1) + pss_right * interp_filter(it2-1,2)

					! inject secondary source
					pnew = pnew + ssw

					! save scattered wavefield at coarse sampling 
					scat_wfld2(:,:,its) = scat_wfld2(:,:,its) + pnew * interp_filter(it2,1)
					scat_wfld2(:,:,its+1) = scat_wfld2(:,:,its+1) + pnew * interp_filter(it2,2)

					! record data at fine sampling
					if (dip .eqv. .true.) then
						do ir=1,nr
							dataw(itw,ir,is) = dataw(itw,ir,is) + pnew(recv_coord(ir,1),recv_coord(ir,2)) 
							dataw(itw,ir,is) = dataw(itw,ir,is) - pnew(recv_coord(ir,1)+shift,recv_coord(ir,2)) 
						end	do
					else
						do ir=1,nr
							dataw(itw,ir,is) = dataw(itw,ir,is) + pnew(recv_coord(ir,1),recv_coord(ir,2)) 
						end	do
					end if

					! switch pointers within the same sub-block
					ptemp => pold
					pold => pcur 
					pcur => pnew
					pnew => ptemp	

				end do
	
				! finished scattering and recording for the sub-block
				! switching pointers for the secondary sources
				pss_temp => pss_left
				pss_left => pss_right
				pss_right => pss_temp
				pss_right = 0.0

				! switch pointers for the secondary source before time derivatives
				pss_junk => pss1
				pss1 => pss2
				pss2 => pss3 
				pss3 => pss_junk
				pss3 = 0.0

			end do

			! save the first scattered wavefield of leg 1 on disk 
			if (save_scat .eqv. .true.) then
				call sep_write(scat_wfld2(z_pad+1:z_pad+nz,x_pad+1:x_pad+nx,:),"scat_wfld2_leg2")
			end if

 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!! FINISHED COMPUTATION OF LEG 2 !!!!!!!!!!!!!!!!!!!"!
			write(0,'(a)') "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"!
 			!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	

		end if
		
  		write(0,'(a,i4,a,i4)') "SHOT ",is," OUT OF",ns  	
		
		! interpolate data to receiver sampling for this shot
    	call Lr_2d_op2(.true.,.false.,data(:,:,is),dataw(:,:,is))	

  	end do	
		
  	call system_clock(c_2)
  	write(0,'(a,f10.1,a)') "time spent computing: ",(c_2-c_1)/cr," [s]"  

	! WRITE DATA ON DISK
   	write(0,fmt2) "writing data [Pa] on disk"
  	call sep_write(data)
   	write(0,fmt2) "writing data [Pa] on disk: OK"
   	
  	call to_history("n1",nts)
  	call to_history("o1",ots)
  	call to_history("d1",dts)
  	call to_history("label1","time [s]")
  
  	call to_history("n2",nr)
  	call to_history("o2",ox_recv)
  	call to_history("d2",dx*dr)
  	call to_history("label2","receivers [km]")

  	call to_history("n3",ns)
  	call to_history("o3",ox_src)
  	call to_history("d3",dx*ds)
  	call to_history("label3","sources [km]")

	! WRITE WAVEFIELDS ON DISK
	if (save_src .eqv. .true.) then
	
		call to_history("n1",nz,"src_wfld")  	
 		call to_history("o1",oz_true,"src_wfld")  	
 		call to_history("d1",dz,"src_wfld") 
  		call to_history("label1","z [km]","src_wfld")
 	
	 	call to_history("n2",nx,"src_wfld")  	
 		call to_history("o2",ox_true,"src_wfld")  	
 		call to_history("d2",dx,"src_wfld") 	 		 	
  		call to_history("label2","x [km]","src_wfld")

 		call to_history("n3",nts,"src_wfld")  
 		call to_history("o3",ots,"src_wfld")  	
 		call to_history("d3",dts,"src_wfld")
  		call to_history("label3","time [s]","src_wfld")
  	end if	

	if (save_scat) then
	
		call to_history("n1",nz,"scat_wfld1_leg1")  	
 		call to_history("o1",oz_true,"scat_wfld1_leg1")  	
 		call to_history("d1",dz,"scat_wfld1_leg1")  	
  		call to_history("label1","z [km]","scat_wfld1_leg1")  	
 	
	 	call to_history("n2",nx,"scat_wfld1_leg1")  	
 		call to_history("o2",ox_true,"scat_wfld1_leg1")  	
 		call to_history("d2",dx,"scat_wfld1_leg1")  		 	
  		call to_history("label2","x [km]","scat_wfld1_leg1")  	

 		call to_history("n3",nts,"scat_wfld1_leg1")  	
 		call to_history("o3",ots,"scat_wfld1_leg1")  	
 		call to_history("d3",dts,"scat_wfld1_leg1")  	
  		call to_history("label3","time [s]","scat_wfld1_leg1")  	

		call to_history("n1",nz,"scat_wfld2_leg1")  	
 		call to_history("o1",oz_true,"scat_wfld2_leg1")  	
 		call to_history("d1",dz,"scat_wfld2_leg1")  	
  		call to_history("label1","z [km]","scat_wfld2_leg1")  	
 	
	 	call to_history("n2",nx,"scat_wfld2_leg1")  	
 		call to_history("o2",ox_true,"scat_wfld2_leg1")  	
 		call to_history("d2",dx,"scat_wfld2_leg1")  		 	
  		call to_history("label2","x [km]","scat_wfld2_leg1")  	

 		call to_history("n3",nts,"scat_wfld2_leg1")  	
 		call to_history("o3",ots,"scat_wfld2_leg1")  	
 		call to_history("d3",dts,"scat_wfld2_leg1")  	
  		call to_history("label3","time [s]","scat_wfld2_leg1")  
  		
		call to_history("n1",nz,"scat_wfld1_leg2")  	
 		call to_history("o1",oz_true,"scat_wfld1_leg2")  	
 		call to_history("d1",dz,"scat_wfld1_leg2")  	
  		call to_history("label1","z [km]","scat_wfld1_leg2")  	
 	
	 	call to_history("n2",nx,"scat_wfld1_leg2")  	
 		call to_history("o2",ox_true,"scat_wfld1_leg2")  	
 		call to_history("d2",dx,"scat_wfld1_leg2")  		 	
  		call to_history("label2","x [km]","scat_wfld1_leg2")  	

 		call to_history("n3",nts,"scat_wfld1_leg2")  	
 		call to_history("o3",ots,"scat_wfld1_leg2")  	
 		call to_history("d3",dts,"scat_wfld1_leg2")  	
  		call to_history("label3","time [s]","scat_wfld1_leg2")  	

		call to_history("n1",nz,"scat_wfld2_leg2")  	
 		call to_history("o1",oz_true,"scat_wfld2_leg2")  	
 		call to_history("d1",dz,"scat_wfld2_leg2")  	
  		call to_history("label1","z [km]","scat_wfld2_leg2")  	
 	
	 	call to_history("n2",nx,"scat_wfld2_leg2")  	
 		call to_history("o2",ox_true,"scat_wfld2_leg2")  	
 		call to_history("d2",dx,"scat_wfld2_leg2")  		 	
  		call to_history("label2","x [km]","scat_wfld2_leg2")  	

 		call to_history("n3",nts,"scat_wfld2_leg2")  	
 		call to_history("o3",ots,"scat_wfld2_leg2")  	
 		call to_history("d3",dts,"scat_wfld2_leg2")  	
  		call to_history("label3","time [s]","scat_wfld2_leg2")   			

	end if

 	call sep_close()

end program


